package sk.upjs.js;

import org.springframework.stereotype.Component;
import org.springframework.validation.Errors;
import org.springframework.validation.Validator;

@Component
public class StudentValidator implements Validator {

	public void validate(Object o, Errors chyby) {
		Student student = (Student) o;
		if(student.getMeno() == null || student.getMeno().trim().length() == 0) {
			chyby.reject("meno", null, "Meno musi byt neprazdne.");
		}
		if(student.getPriezvisko() == null || student.getPriezvisko().trim().length() == 0) {
			chyby.reject("priezvisko", null, "Priezvisko musi byt neprazdne.");
		}		
		if(student.getRocnik() < 1 || student.getRocnik() > 5) {
			chyby.reject("rocnik", null, "Rocnik musi byt medzi 1 a 5.");
		}
	}

	
	public boolean supports(Class clazz) {
		return Student.class.isAssignableFrom(clazz);
	}

}
