package sk.upjs.js;

import java.util.Map;
import java.util.TreeMap;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.validation.Errors;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;

@Controller
@RequestMapping("/zapisStudenta.do")
public class VytvorStudenta {
	@Autowired
	private Database database;
	
	@Autowired
	private StudentValidator studentValidator;
	
	@ModelAttribute("povoleneRocniky")
	public Map<Integer, String> povoleneRocniky() {
		Map<Integer, String> hodnoty = new TreeMap<Integer, String>();
		hodnoty.put(1, "prvk");
		hodnoty.put(2, "druhk");
		hodnoty.put(3, "tretiak");
		hodnoty.put(4, "tvrtk");
		hodnoty.put(5, "piatak");

		return hodnoty;
	}
	
	@RequestMapping(method=RequestMethod.GET)
	public Student zobrazStudenta(Integer id) {
		Student s = null;
		if(id == null) {
			s = new Student();
			s.setRocnik(1);
		} else {
			s = database.findById(id);
			if(s == null) {
				throw new IllegalArgumentException("Take ID nejestvuje");
			}
		}			
		return s;
	}
	
	@RequestMapping(method=RequestMethod.POST)
	public String zapis(Student student, Errors chyby) {
		studentValidator.validate(student, chyby);
		if(!chyby.hasErrors()) {
			database.saveOrUpdate(student);
			System.out.println("Zapisal som studenta.");
			
			return "redirect:listStudents.do";
		} else {
			System.out.println("Chyba v zadanych udajoch.");
			return null;
		}
	}

}
